Attribute VB_Name = "CRSUtils"
'
' Copyright 2000, Charles Severance - All Rights Reserved
'
' This software is AS IS with no warranty
'

Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer
Option Explicit

' Debug Constants
Dim DebugFile As Integer


Dim CRSInBatchMode As Integer  ' 0 Is normal 1 is Debug Mode

' Variables for CRS_RecDir

Dim CRS_RecDirList() As String
Dim CRS_RecDirCount As Integer
Dim CRS_RecDirLast As Integer

Public Const INFINITE = &HFFFF
'STARTINFO constants
Private Const STARTF_USESHOWWINDOW = &H1
Public Enum enSW
     SW_HIDE = 0
     SW_NORMAL = 1
     SW_MAXIMIZE = 3
     SW_MINIMIZE = 6
End Enum

Private Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type

Private Type STARTUPINFO
                 cb As Long
                 lpReserved As String
                 lpDesktop As String
                 lpTitle As String
                 dwX As Long
                 dwY As Long
                 dwXSize As Long
                 dwYSize As Long
                 dwXCountChars As Long
                 dwYCountChars As Long
                 dwFillAttribute As Long
                 dwFlags As Long
                 wShowWindow As Integer
                 cbReserved2 As Integer
                 lpReserved2 As Byte
                 hStdInput As Long
                 hStdOutput As Long
                 hStdError As Long
End Type

Type SECURITY_ATTRIBUTES
                 nLength As Long
                 lpSecurityDescriptor As Long
                 bInheritHandle As Long
End Type
          
Public Enum enPriority_Class
             NORMAL_PRIORITY_CLASS = &H20
             IDLE_PRIORITY_CLASS = &H40
             HIGH_PRIORITY_CLASS = &H80
End Enum
          
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" _
    (ByVal lpApplicationName As String, ByVal lpCommandLine As String, _
     lpProcessAttributes As SECURITY_ATTRIBUTES, lpThreadAttributes As _
     SECURITY_ATTRIBUTES, ByVal bInheritHandles As Long, ByVal _
     dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDriectory _
     As String, lpStartupInfo As STARTUPINFO, lpProcessInformation _
     As PROCESS_INFORMATION) As Long

Private Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

' Thanks to http://home.sol.no/~jansh/vb/vbfaq.htm

Private Declare Function ShellExecute Lib "shell32.dll" Alias _
     "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As _
     String, ByVal lpFile As String, ByVal lpParameters As String, _
     ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Sub LaunchBrowser(FormName As Form, url As String)
  Dim ret&
  ret& = ShellExecute(FormName.hwnd, "Open", url, "", App.Path, 1)
End Sub
 
Sub CRS_Sleep(PauseTime As Integer)
    Dim Start, Finish, TotalTime

    Start = Timer   ' Set start time.
    Do While (Timer < Start + PauseTime) And (Timer >= Start)
        DoEvents    ' Yield to other processes.
    Loop
End Sub


' http://www.global.com.gr/~vbasic/
' http://www.missouri.edu/~finaidtk/supshell.htm

Public Function SuperShell(ByVal App As String, ByVal WorkDir As String, _
    dwMilliseconds As Long, ByVal start_size As enSW, ByVal Priority_Class _
    As enPriority_Class) As Boolean

    Dim pclass As Long
    Dim sinfo As STARTUPINFO
    Dim pinfo As PROCESS_INFORMATION
    'Not used, but needed
    Dim sec1 As SECURITY_ATTRIBUTES
    Dim sec2 As SECURITY_ATTRIBUTES
             
    sec1.nLength = Len(sec1)
    sec2.nLength = Len(sec2)
    sinfo.cb = Len(sinfo)
             
    sinfo.dwFlags = STARTF_USESHOWWINDOW
    sinfo.wShowWindow = start_size

    pclass = Priority_Class
             
    If CreateProcess(vbNullString, App, sec1, sec2, False, pclass, _
               0&, WorkDir, sinfo, pinfo) Then
      WaitForSingleObject pinfo.hProcess, dwMilliseconds
      SuperShell = True
    Else
      SuperShell = False
    End If

End Function

' CRS_Basename - Get the file name without any type of suffix

Public Function CRS_Basename(FileStr As String) As String
    Dim I As Integer
    Dim J As Integer
    
    I = Len(FileStr)
    J = 0
    CRS_Basename = Trim(FileStr)
    While I > 1
        If Mid(FileStr, I, 1) = "." Then
            CRS_Basename = Trim(Left(FileStr, I - 1))
            Exit Function
        End If
        I = I - 1
    Wend
End Function

' CRS_FixFileName - Put a File name into cannonical form
'  No more than one backslash

Public Function CRS_FixFileName(FileName) As String
    Dim TmpName As String
    Dim ChVal As String
    Dim I, J As Integer
    
    If Len(Trim(FileName)) = 0 Then Exit Function
    
    TmpName = Mid(FileName, 1, 1)  ' Put in the first character
    For I = 2 To Len(FileName)
        ChVal = Mid(FileName, I, 1)
        If Mid(TmpName, Len(TmpName), 1) <> "\" Or ChVal <> "\" Then
            TmpName = TmpName & ChVal
        End If
    Next I
     
    CRS_FixFileName = TmpName
    
End Function

' CRS_FixDir - Put a directory name into cannonical form
'  No more than one backslash
'  Backslash at the end

Public Function CRS_FixDirName(DirName) As String
    Dim TmpName As String
    Dim ChVal As String
    Dim I, J As Integer
    
    If Len(Trim(DirName)) = 0 Then Exit Function
    
    TmpName = CRS_FixFileName(DirName)

    If Mid(TmpName, Len(TmpName), 1) <> "\" Then
        TmpName = TmpName & "\"
    End If
    
    CRS_FixDirName = TmpName
    
End Function

' If a drive letter is part of a path, check to see if it is OK.

Public Function CRS_Chkdrv(DirName As String)
  Dim Errno As Integer
  
  CRS_Chkdrv = False
  If Mid(DirName, 2, 1) = ":" Then
    On Error Resume Next
    ChDrive Left(DirName, 1)
    Errno = Err.Number
    If Errno <> 0 Then
        Debug.Print "CRS_Chkdrv - " & DirName & " Err = "; Errno
    End If
    If Errno = 71 Or Errno = 68 Then
      CRSMsgBox "Error - Drive Not Ready - " & DirName
      On Error GoTo 0
      ChDrive "C"
      Exit Function
    End If
    If Errno <> 0 Then
      CRSMsgBox "Error - Drive Letter wrong (" & Err.Number & ") - " & DirName
      On Error GoTo 0
      ChDrive "C"
      Exit Function
    End If
    ChDrive "C"
    CRS_Chkdrv = True
  End If
End Function

'Make a Directory with a prompt

Public Function CRS_Mkdir(InputDirname As String) As Boolean
  Dim Well As Integer
  Dim QuitMsg As String
  Dim IPos As Integer
  Dim JPos As Integer
  Dim KPos As Integer
  Dim TmpDir As String
  Dim DirName As String
  
  CRS_Mkdir = False
  
  DirName = CRS_FixDirName(InputDirname)
    
  IPos = 1
  If Mid(DirName, 2, 1) = ":" Then
    On Error Resume Next
    ChDrive Left(DirName, 1)
    If Err.Number <> 0 Then
      CRSMsgBox "Error - Drive Letter wrong - " & DirName
      On Error GoTo 0
      Exit Function
    End If
    IPos = 3
  End If
    
' Check to see if Directory Exists

  If Not CRS_ChkDir(DirName) Then
    Well = CRSYesNoBox("OK to create " & DirName)
    If Well <> vbYes Then
        Exit Function
    End If
  End If
    
' Make all of the directories starting from the top down

  Do
    TmpDir = Left(DirName, IPos)
    Debug.Print "CRS_Mkdir Checking "; TmpDir, IPos, DirName
    On Error Resume Next
    ChDir TmpDir
    If Err.Number = 76 Then
      QuitMsg = "Unable to create " & TmpDir
      On Error GoTo WeQuit:
      Debug.Print "CRS_Mkdir Making "; TmpDir, IPos, DirName
      MkDir TmpDir
      QuitMsg = "Unable to enter " & TmpDir
      ChDir TmpDir
    End If
    On Error GoTo 0
    KPos = InStr(IPos + 1, DirName, "\")
    If KPos = 0 Then
      IPos = Len(DirName)
    Else
      IPos = KPos
    End If
  Loop While Len(Trim(TmpDir)) < Len(Trim(DirName))
  CRS_Mkdir = True
  Exit Function
WeQuit:
    CRSMsgBox QuitMsg
    CRS_Mkdir = False
End Function

Public Function CRS_ChkDir(InputDirname As String)
    Dim AttrVal As Integer
    Dim DirName As String
    
 
    CRS_Debug "CRS_ChkDir " & InputDirname
  
    DirName = CRS_FixDirName(InputDirname)
    On Error Resume Next
    AttrVal = GetAttr(DirName) And vbDirectory
    If Err.Number <> 0 Or AttrVal = 0 Then
      CRS_ChkDir = False
    Else
      CRS_ChkDir = True
    End If
    On Error GoTo 0
End Function

Public Function CRS_ChkFile(FileName As String)
  Dim INum As Integer
  
  CRS_Debug "CRS_ChkFile " & FileName
  
  INum = FreeFile
  CRS_ChkFile = True
  On Error Resume Next
  Open FileName For Input As #INum
  If Err.Number <> 0 Then
    CRS_ChkFile = False
  End If
  On Error GoTo 0
  Close #INum
End Function

Public Function CRS_MustExist(FileName As String)
  Dim INum As Integer
  INum = FreeFile
  CRS_MustExist = True
  On Error Resume Next
  Open FileName For Input As #INum
  If Err.Number <> 0 Then
    CRSMsgBox FileName & " does not exist " & Err.Description
    CRS_MustExist = False
  End If
  Close #INum
  On Error GoTo 0
End Function

' Remove the files in a directory - with some error checking

Public Function CRS_KillDir(InputDirname As String) As Boolean
    Dim IsFiles As String   'used to see if files exists
    Dim Tmp As String
    Dim SaveStr As String
    Dim IRET As Integer
    Dim DirName As String

    DirName = CRS_FixDirName(InputDirname)
    
    CRS_Debug "Removing a complete directory " & DirName
    CRS_KillDir = False
    Tmp = DirName & "*.*"
    IsFiles = Dir(Tmp, 0)
    If Not IsFiles = "" Then
        If Mid(DirName, 2, 1) = ":" And Len(DirName) <= 4 Then
            CRSMsgBox "This program will not remove a root directory " & DirName
            Exit Function
        End If
        IRET = CRSOKBox("Ok to remove files from " & DirName)
        If IRET <> vbOK Then Exit Function
        On Error Resume Next
        Kill Tmp
        If Err.Number <> 0 Then
            SaveStr = Err.Description
            Tmp = DirName & "*.*"
            IsFiles = Dir(Tmp, 0)
            If IsFiles <> "" Then
                CRSMsgBox "Problems removing file(s) " & IsFiles & " - " & SaveStr
            Else
                CRSMsgBox "Problems removing files in " & InputDirname & " - " & SaveStr
            End If
            On Error GoTo 0
            Exit Function
        End If
        ' Lets make doubly sure
        Tmp = DirName & "*.*"
        IsFiles = Dir(Tmp, 0)
        If IsFiles <> "" Then
            CRSMsgBox "Not all files were removed - " & IsFiles
            On Error GoTo 0
            Exit Function
        End If
    Else
        CRS_Debug "No Files To Clean Up"
    End If
    On Error GoTo 0
    CRS_KillDir = True
End Function

Public Function CRS_DelOK(FileName As String) As Boolean

  Dim IRET As Integer

  CRS_DelOK = True
  
  If Not CRS_ChkFile(FileName) Then Exit Function
  
' File Exists, OK to delete it?

  IRET = CRSOKBox("Ok to remove  " & FileName)
  If IRET <> vbOK Then
    CRS_DelOK = False
    Exit Function
  End If
  On Error Resume Next
  Kill FileName
  If Err.Number <> 0 Then
    CRSMsgBox "Unable to remove " & FileName
    CRS_DelOK = False
  End If
  On Error GoTo 0
End Function

Function CRS_CopyWild(FromDir As String, Pattern As String, ToDir As String) As Boolean
   Dim FileName As String
   Dim MyFromDir As String
   Dim MyToDir As String
   Dim FromFile As String
   Dim ToFile As String
   
   MyFromDir = CRS_FixDirName(FromDir & "\")
   MyToDir = CRS_FixDirName(ToDir & "\")
   
   FileName = Dir(MyFromDir & Pattern)
   While FileName <> ""
        FromFile = MyFromDir & FileName
        ToFile = LCase(MyToDir & FileName)
        On Error Resume Next
        FileCopy FromFile, ToFile
        If Err.Number <> 0 Then
            CRS_CopyWild = False
            Exit Function
        End If
        On Error GoTo 0
        CRS_Debug "Copied " & FromFile & " to " & ToFile
        
        FileName = Dir
   Wend
   CRS_CopyWild = True
End Function

Public Function CRS_Wait(Sec As Integer)
  Dim X As Integer
  X = Timer
  Debug.Print "Waiting...", Sec
  Do
    DoEvents
  Loop While (X + Sec) > Timer And X <= Timer
  Debug.Print "Waited..."
End Function

' Convert 60th's of a second to a time value 00:00:00

Public Function CRS_TicsToTime(Tics As Long) As String

    Dim MyTics As Long
    Dim Hours, Minutes, Seconds As Long
    
    MyTics = Tics / 60 ' No need to deal with those pesky fractions
    
    Hours = Int(MyTics / (60 * 60))
    MyTics = MyTics - Hours * (60 * 60)
    Minutes = Int(MyTics / 60)
    MyTics = MyTics - Minutes * 60
    Seconds = MyTics
    
    CRS_TicsToTime = Format(Hours, "00") + ":" + Format(Minutes, "00") + ":" + Format(Seconds, "00")

End Function

Public Function CRS_TimeToTics(TimeStr As String) As Long

    Dim Splits(10) As String
    Dim Count As Integer
    Dim Hours, Minutes, Seconds As Long
    Dim LocStr As String
    Dim I As Integer
    
    CRS_TimeToTics = 0
    Hours = Minutes = Seconds = 0
    
    LocStr = Trim(TimeStr)
    
    Split LocStr, Splits, Count, ":"

    If Count <= 0 Or Count > 3 Then Exit Function
    
    I = Count  ' Start at the leftmost
    If I > 0 Then
        Seconds = Val(Splits(I))
        I = I - 1
    End If
    If I > 0 Then
        Minutes = Val(Splits(I))
        I = I - 1
    End If
    If I > 0 Then
        Hours = Val(Splits(I))
    End If
    
    Seconds = Seconds + (Minutes * 60) + (Hours * 60 * 60)
    CRS_TimeToTics = Seconds * 60
    
End Function

' Note at the end this will reset the error condition

Public Sub CRS_Debug(OutStr As String)

    Debug.Print OutStr
    
    If DebugFile = 0 Then
        DebugFile = FreeFile
        On Error Resume Next
        Open "C:\Syncdbg.txt" For Output As #DebugFile
        If Err Then
            DebugFile = -1
            On Error GoTo 0
            Exit Sub
         End If
        On Error GoTo 0
    End If
    
    If DebugFile < 0 Then
        Exit Sub
    End If

' If this print fails, it typically means that someone has done a Reset

    On Error Resume Next
    Print #DebugFile, OutStr
    
' Try to reopen as Append

    If Err Then
        DebugFile = FreeFile
        On Error Resume Next
        Open "C:\Syncdbg.txt" For Append As #DebugFile
        Print #DebugFile, OutStr
        If Err Then
            DebugFile = -1
            On Error GoTo 0
            Exit Sub
         End If
        On Error GoTo 0
    End If
    On Error GoTo 0

End Sub

Sub CRSMsgBatch(Value As Boolean)
    If Value Then
        CRSInBatchMode = 1
    Else
        CRSInBatchMode = 0
    End If
End Sub

Function CRSCheckBatchMode() As Boolean
    CRSCheckBatchMode = (CRSInBatchMode <> 0)
End Function

Sub CRSMsgBox(Message As String)
    If CRSInBatchMode = 0 Then
        MsgBox Message
    End If
End Sub

Function CRSOKBox(Message As String)
    Dim I
    If CRSInBatchMode = 0 Then
        I = MsgBox(Message, vbOK)
        CRSOKBox = I
    Else
        CRSOKBox = vbOK
    End If
End Function

Function CRSOKCancelBox(Message As String)
    Dim I
    If CRSInBatchMode = 0 Then
        I = MsgBox(Message, vbOKCancel)
        CRSOKCancelBox = I
    Else
        CRSOKCancelBox = vbOK
    End If
End Function

Function CRSYesNoBox(Message As String)
    Dim I
    If CRSInBatchMode = 0 Then
        I = MsgBox(Message, vbYesNoCancel)
        CRSYesNoBox = I
    Else
        CRSYesNoBox = vbYes
    End If
End Function

Public Function SizeStr(Size As Variant) As String
   SizeStr = Size & " Bytes"
   If Size > 5000 Then
      SizeStr = Int(Size / 1024) & " KB"
   End If
   If Size > 5000000 Then
      SizeStr = Int(Size / (1024# * 1024#)) & " MB"
   End If
End Function

Public Sub ParsePath(Parent As String, Name As String, InPath As String)
    Dim I, J, K As Integer
    Dim TmpName As String
    Dim endname, enddir, begname, lenname As Integer
    
    ' C:\My Documents\lectures\food\
    TmpName = LCase(Trim(InPath))
    J = Len(TmpName)
    ' Switched these around /Chuck 12/30/00
    
    Name = TmpName
    Parent = ""
    
    If J < 2 Then Exit Sub
    If Mid(TmpName, J, 1) = "\" Then ' Slash at the end
    
      J = J - 1  ' Skip the \
      If Mid(TmpName, J, 1) = "\" Then
        Exit Sub  ' two slashes at the end :(
      End If
    End If

    K = -1
    For I = J To 1 Step -1  ' Scan back for the next \
        If Mid(TmpName, I, 1) = "\" Then
            K = I
            Exit For
        End If
    Next I

    If K = -1 Then Exit Sub  ' Nothing found :(
    
    endname = J
    enddir = K
    begname = K + 1
    lenname = (endname - begname) + 1
    
    If lenname < 1 Or enddir < 1 Then
        Exit Sub ' Nothing there
    End If
    
    ' After all that
    
    Name = Mid(TmpName, begname, lenname)
    Parent = Mid(TmpName, 1, enddir)
End Sub

' CRS_RecDir - Behaves like Dir - except that it only does directories and recurses
'
' Test:
'  Dim Tmp As String
'
'  Tmp = CRS_RecDir("C:\my documents\")
'  While Tmp <> ""
'    Debug.Print Tmp
'    Tmp = CRS_RecDir("")
'  Wend

Public Function CRS_RecDir(PathName As String) As String

  ' Now we have a path :) Lets fill up the array
  
  If Len(Trim(PathName)) <> 0 Then

    ReDim CRS_RecDirList(1000)
  
    CRS_RecDirCount = 0
    CRS_RecDirLast = 0
  
    CRS_Descend PathName, " ", 0
    
    If CRS_RecDirCount > 0 Then
      CRS_RecDirLast = 1
    Else
      CRS_RecDirLast = 0
    End If
  
  End If
  
  ' All filled up - or no parameter - pull out an entry

  If CRS_RecDirCount <= 0 Then
    CRS_RecDirCount = 0
    CRS_RecDir = ""
    Exit Function
  End If
  If CRS_RecDirLast <= CRS_RecDirCount Then
    CRS_RecDir = CRS_RecDirList(CRS_RecDirLast)
    CRS_RecDirLast = CRS_RecDirLast + 1
    Exit Function
  End If
    ' We are done - clean it up
  Erase CRS_RecDirList
  CRS_RecDirLast = 0
  CRS_RecDirCount = 0
  CRS_RecDir = ""

End Function

Private Sub CRS_Descend(BasePath As String, PathName As String, Depth As Integer)
  Dim SubDirs(100) As String
  Dim I, Count As Integer
  
  Dim MyFile, MyName, MyPath, LocalPath

  If (Depth > 10) Then Exit Sub  ' Don't want to get too carried away
 
  If Right(BasePath, 1) <> "\" Then
      MyPath = BasePath & "\"
  Else
      MyPath = BasePath
  End If
    
  If Len(Trim(PathName)) <> 0 Then
    If Right(PathName, 1) <> "\" Then
      LocalPath = PathName & "\"
    Else
      LocalPath = PathName
    End If
    MyPath = MyPath & LocalPath
  End If
  
  ' At this point, MyPath WILL end with a slash!
  
  Count = 0
  MyName = Dir(MyPath, vbDirectory)   ' Retrieve the first entry.
  Do While MyName <> ""   ' Start the loop.
    ' Ignore the current directory and the encompassing directory.
    If MyName <> "." And MyName <> ".." Then
        ' Use bitwise comparison to make sure MyName is a directory.

        If (GetAttr(MyPath & MyName) And vbDirectory) = vbDirectory Then
            Debug.Print Depth, MyPath & MyName  ' Display entry only if it
            If (Count < 100) Then Count = Count + 1
            SubDirs(Count) = LocalPath & MyName
            If CRS_RecDirCount < UBound(CRS_RecDirList) Then
              CRS_RecDirCount = CRS_RecDirCount + 1
              CRS_RecDirList(CRS_RecDirCount) = LocalPath & MyName
            End If
        End If  ' it represents a directory.
    End If
    MyName = Dir    ' Get next entry.
  Loop
  
  For I = 1 To Count
    CRS_Descend BasePath, SubDirs(I), Depth + 1
  Next I
  
  
End Sub
